"""
    FastAPI

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)  # noqa: E501

    The version of the OpenAPI document: 0.1.0
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from code_size_analyzer_client.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from code_size_analyzer_client.exceptions import ApiAttributeError


def lazy_import():
    from code_size_analyzer_client.model.classification_rule import ClassificationRule
    globals()['ClassificationRule'] = ClassificationRule


class MapFileRequest(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        lazy_import()
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'map_file': (str,),  # noqa: E501
            'stack_name': (str,),  # noqa: E501
            'target_part': (str,),  # noqa: E501
            'compiler': (str,),  # noqa: E501
            'target_board': (str,),  # noqa: E501
            'app_name': (str,),  # noqa: E501
            'project_file': (str,),  # noqa: E501
            'project_file_name': (str,),  # noqa: E501
            'branch_name': (str,),  # noqa: E501
            'build_number': (str,),  # noqa: E501
            'commit': (str,),  # noqa: E501
            'store_results': (bool,),  # noqa: E501
            'build_url': (str,),  # noqa: E501
            'classification_rules': ([ClassificationRule],),  # noqa: E501
            'ignore_default_rules': (bool,),  # noqa: E501
            'uc_component_branch_name': (str,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'map_file': 'map_file',  # noqa: E501
        'stack_name': 'stack_name',  # noqa: E501
        'target_part': 'target_part',  # noqa: E501
        'compiler': 'compiler',  # noqa: E501
        'target_board': 'target_board',  # noqa: E501
        'app_name': 'app_name',  # noqa: E501
        'project_file': 'project_file',  # noqa: E501
        'project_file_name': 'project_file_name',  # noqa: E501
        'branch_name': 'branch_name',  # noqa: E501
        'build_number': 'build_number',  # noqa: E501
        'commit': 'commit',  # noqa: E501
        'store_results': 'store_results',  # noqa: E501
        'build_url': 'build_url',  # noqa: E501
        'classification_rules': 'classification_rules',  # noqa: E501
        'ignore_default_rules': 'ignore_default_rules',  # noqa: E501
        'uc_component_branch_name': 'uc_component_branch_name',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, map_file, stack_name, target_part, compiler, *args, **kwargs):  # noqa: E501
        """MapFileRequest - a model defined in OpenAPI

        Args:
            map_file (str): base64-encoded string representation of map file contents
            stack_name (str): end product name; e.g. zigbee
            target_part (str): target part OPN; e.g. 'efr32mg22c224f512im40'
            compiler (str): compiler that produced the map file.  Must be one of 'iar' or 'gcc'

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            target_board (str): Optional board name; e.g. brd4181a.  Required if store_results is True. [optional]  # noqa: E501
            app_name (str): Name of application; e.g. soc_empty.  Required if store_results is True. [optional]  # noqa: E501
            project_file (str): base64-encoded string representation of project file contents. [optional]  # noqa: E501
            project_file_name (str): project file name. [optional]  # noqa: E501
            branch_name (str): branch name; e.g. 'develop/22q2'.  Required if store_results is True. [optional]  # noqa: E501
            build_number (str): build number; e.g. b1234.  Required if store_results is True. [optional]  # noqa: E501
            commit (str): [optional]  # noqa: E501
            store_results (bool): set to True to store results to reporting database. [optional]  # noqa: E501
            build_url (str): [optional]  # noqa: E501
            classification_rules ([ClassificationRule]): optional list of ClassificationRule objects to add additional classification rules. [optional]  # noqa: E501
            ignore_default_rules (bool): Set to true to ignore default classification rules and exclusively use rules from classification_rules. [optional] if omitted the server will use the default value of False  # noqa: E501
            uc_component_branch_name (str): branch name for uc component database; e.g. 'develop/22q2'. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', True)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.map_file = map_file
        self.stack_name = stack_name
        self.target_part = target_part
        self.compiler = compiler
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, map_file, stack_name, target_part, compiler, *args, **kwargs):  # noqa: E501
        """MapFileRequest - a model defined in OpenAPI

        Args:
            map_file (str): base64-encoded string representation of map file contents
            stack_name (str): end product name; e.g. zigbee
            target_part (str): target part OPN; e.g. 'efr32mg22c224f512im40'
            compiler (str): compiler that produced the map file.  Must be one of 'iar' or 'gcc'

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            target_board (str): Optional board name; e.g. brd4181a.  Required if store_results is True. [optional]  # noqa: E501
            app_name (str): Name of application; e.g. soc_empty.  Required if store_results is True. [optional]  # noqa: E501
            project_file (str): base64-encoded string representation of project file contents. [optional]  # noqa: E501
            project_file_name (str): project file name. [optional]  # noqa: E501
            branch_name (str): branch name; e.g. 'develop/22q2'.  Required if store_results is True. [optional]  # noqa: E501
            build_number (str): build number; e.g. b1234.  Required if store_results is True. [optional]  # noqa: E501
            commit (str): [optional]  # noqa: E501
            store_results (bool): set to True to store results to reporting database. [optional]  # noqa: E501
            build_url (str): [optional]  # noqa: E501
            classification_rules ([ClassificationRule]): optional list of ClassificationRule objects to add additional classification rules. [optional]  # noqa: E501
            ignore_default_rules (bool): Set to true to ignore default classification rules and exclusively use rules from classification_rules. [optional] if omitted the server will use the default value of False  # noqa: E501
            uc_component_branch_name (str): branch name for uc component database; e.g. 'develop/22q2'. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.map_file = map_file
        self.stack_name = stack_name
        self.target_part = target_part
        self.compiler = compiler
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
